package ity.opencraft;

import ity.opencraft.io.Screen;
import ity.opencraft.io.Window;
import ity.opencraft.physics.PhysicsManager;
import ity.opencraft.render.Renderer;
import ity.opencraft.util.TextureLoader;
import ity.opencraft.backends.Backend;
import ity.opencraft.backends.BackendScanner;
import ity.opencraft.backends.CurrentBackend;
import ity.opencraft.io.Windows;
import org.lwjgl.glfw.GLFW;

public class Main {
    public static void main(String[] args) {
        BackendScanner.scan();
        CurrentBackend.backend = Backend.GL;

        Screen.init();
        Window win = new Window();
        win.init(1000, 1000, "OpenCraft v0.0.1");
        win.select();
        win.setCursor(GLFW.GLFW_CURSOR_DISABLED);
        Screen.put(Windows.MAIN.toString(), win);
        TextureLoader.init();
        Renderer.init();

        long mOld = System.currentTimeMillis();
        while(!win.shouldClose()) {
            long delta = System.currentTimeMillis() - mOld;
            mOld = System.currentTimeMillis();
            PhysicsManager.update(delta);
            Renderer.render(delta);
            win.swap();
            GLFW.glfwPollEvents();
        }
        for(Thread worker : Renderer.worldGenWorkers) {
            worker.stop();
        }
    }
}
