package ity.opencraft.backends;

import org.reflections.Reflections;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import java.util.function.Supplier;

public class BackendScanner {
    public static Map<Class<? extends Backended>, Map<Backend, Supplier<Backended>>> backends = new HashMap<>();
    public static void scan() {
        ArrayList<Class<? extends Backended>> subT = new ArrayList<>();
        for(Package p : Package.getPackages()) {
            Set<Class<? extends Backended>> subs = new Reflections(p.getName()).getSubTypesOf(Backended.class);
            for(Class<? extends Backended> sub : subs) {
                if(!subT.contains(sub)) subT.add(sub);
            }
        }
        for(Class<? extends Backended> cls : subT) {
            if(cls.getSuperclass() == Backended.class) {
                for(Class<? extends Backended> clsB : subT) {
                    if(clsB.getSuperclass() == cls) {
                        if(clsB.isAnnotationPresent(BackendImpl.class)) {
                            Map<Backend, Supplier<Backended>> bck = null;
                            Backend backend = clsB.getAnnotation(BackendImpl.class).value();
                            Supplier<Backended> backendImpl = (() -> {
                                try {
                                    return clsB.getConstructor().newInstance();
                                } catch (InstantiationException | NoSuchMethodException | InvocationTargetException | IllegalAccessException e) {
                                    e.printStackTrace();
                                }
                                return null;
                            });
                            if(!backends.containsKey(cls)) {
                                bck = new HashMap<>();
                                bck.put(backend, backendImpl);
                                backends.put(cls, bck);
                            }
                            else {
                                bck = backends.get(cls);
                                bck.put(backend, backendImpl);
                            }
                        }
                    }
                }
            }
        }
    }
}
