package ity.opencraft.io;

import org.joml.Vector2f;
import org.lwjgl.glfw.GLFW;
import org.lwjgl.glfw.GLFWCursorPosCallback;
import org.lwjgl.glfw.GLFWKeyCallback;
import org.lwjgl.glfw.GLFWMouseButtonCallback;

public class Mouse {
    private final Vector2f cursorPos = new Vector2f();
    private final boolean[] buttons = new boolean[GLFW.GLFW_MOUSE_BUTTON_LAST];
    public void init(long wID) {
        GLFW.glfwSetCursorPosCallback(wID, new GLFWCursorPosCallback() {
            public void invoke(long window, double xPos, double yPos) {
                cursorPos.set(xPos, yPos);
            }
        });
        GLFW.glfwSetMouseButtonCallback(wID, new GLFWMouseButtonCallback() {
            public void invoke(long window, int button, int action, int mods) {
                buttons[button] = (action != GLFW.GLFW_RELEASE);
            }
        });
    }

    public Vector2f getCursorPos() {
        return new Vector2f(cursorPos);
    }

    public boolean isButtonPressed(int button) {
        return buttons[button];
    }
}
