package ity.opencraft.physics;

import ity.opencraft.client.ViewportCamera;
import ity.opencraft.io.Screen;
import ity.opencraft.io.Window;
import ity.opencraft.render.Renderer;
import ity.opencraft.world.Blocks;
import ity.opencraft.world.Chunk;
import ity.opencraft.io.Windows;
import ity.opencraft.world.World;
import org.joml.*;
import org.lwjgl.glfw.GLFW;

import java.lang.Math;

// TODO clean up PlayerMovement, it handles too much
public class PlayerMovement {
    private static final float movSpeed = 0.8f;
    private static final float jumpSpeed = 2.5f;
    private static final float rotSpeed = 0.1f;
    private static Vector2f lastMouse;
    private static Vector3i playerChunk = new Vector3i();

    private static boolean keyLeftIsDown = false;
    private static boolean keyRightIsDown = false;

    public static boolean moveTo(Vector3f dest) {
        if(true || !World.getBlockAt((int)(dest.x+0.5), (int)(dest.y-1.0), (int)(dest.z+0.5)).isSolid() && !World.getBlockAt((int)(dest.x+0.5), (int)(dest.y), (int)(dest.z+0.5)).isSolid()) {
            ViewportCamera.pos.set(dest);
            return true;
        } else return false;
    }

    public static boolean isOnGround() {
        return World.getBlockAt((int)(ViewportCamera.pos.x+0.5), (int)(ViewportCamera.pos.y-1.5), (int)(ViewportCamera.pos.z+0.5)).isSolid();
    }

    static class WTFException extends RuntimeException {
        public WTFException() {
            super("WTF just happened??? Did the universe break???");
        }
    }

    private static Vector3i axisAlign(Vector3d in) {
        if(Math.abs(in.x) > Math.abs(in.y) && Math.abs(in.x) > Math.abs(in.z)) {
            return new Vector3i((int)Math.signum(in.x), 0, 0);
        } else if(Math.abs(in.y) > Math.abs(in.x) && Math.abs(in.y) > Math.abs(in.z)) {
            return new Vector3i(0, (int)Math.signum(in.y), 0);
        } else if(Math.abs(in.z) > Math.abs(in.x) && Math.abs(in.z) > Math.abs(in.y)) {
            return new Vector3i(0, 0, (int)Math.signum(in.z));
        } else return new Vector3i(0, 0, 0);
    }

    // TODO: Fix the NaN problem
    // Sometimes all three values in pos turn to NaN. rot untested.
    /**
     * Advance the player movement physics
     * @param delta The delta time, in seconds.
     */
    public static void update(float delta) {
        Vector3i newPlayerChunk = new Vector3i((int)(ViewportCamera.pos.x+(0))/ Chunk.size, (int)(ViewportCamera.pos.y+(0))/Chunk.size, (int)(ViewportCamera.pos.z+(0))/Chunk.size);
        if(!newPlayerChunk.equals(playerChunk)) {
            Renderer.doChunk();
        }
        playerChunk = newPlayerChunk;
        Window main = Screen.get(Windows.MAIN.toString());
        if(main.getKeyboard().isKeyDown(GLFW.GLFW_KEY_F11)) {
            if(main.maximized)
                main.restore();
            else
                main.fullscreen();
        }

        if(lastMouse == null) {
            lastMouse = main.getMouse().getCursorPos();
        } else {
            Vector2f diff = main.getMouse().getCursorPos().sub(lastMouse);
            lastMouse = main.getMouse().getCursorPos();
            float toX = diff.y*rotSpeed;
            ViewportCamera.rot.x += diff.y*rotSpeed;
            ViewportCamera.rot.y -= diff.x*rotSpeed;

            // Damn bratty rotation! Clamping correction needed!!!
            if(ViewportCamera.rot.x < 90.01f) {
                ViewportCamera.rot.x = 90.01f;
            } else if (ViewportCamera.rot.x > 269.01f) {
                ViewportCamera.rot.x = 269.01f;
            }
            if(ViewportCamera.rot.y > 360) {
                ViewportCamera.rot.y = 0;
            } else if(ViewportCamera.rot.y < 0) {
                ViewportCamera.rot.y = 360;
            }
        }
        Vector3f rightVector = ViewportCamera.rightVector();
        Vector3f forwardVector = ViewportCamera.forwardVector();
        Vector3f posCopy = new Vector3f();
        float mult = 1f;
        if(main.getKeyboard().isKeyDown(GLFW.GLFW_KEY_LEFT_SHIFT)) {
            mult = 10f;
        }
        if(main.getKeyboard().isKeyDown(GLFW.GLFW_KEY_S)) {
            posCopy.add(new Vector3f(forwardVector.x, 0, forwardVector.z).normalize().mul(-delta*movSpeed*mult));
        } else if(main.getKeyboard().isKeyDown(GLFW.GLFW_KEY_W)) {
            posCopy.add(new Vector3f(forwardVector.x, forwardVector.y, forwardVector.z).normalize().mul(delta*movSpeed*mult));
        } if(main.getKeyboard().isKeyDown(GLFW.GLFW_KEY_A)) {
            posCopy.add(new Vector3f(rightVector.x, 0, rightVector.z).normalize().mul(-delta*movSpeed*mult));
        } else if(main.getKeyboard().isKeyDown(GLFW.GLFW_KEY_D)) {
            posCopy.add(new Vector3f(rightVector.x, 0, rightVector.z).normalize().mul(delta*movSpeed*mult));
        }
//        if(main.getKeyboard().isKeyDown(GLFW.GLFW_KEY_LEFT_SHIFT)) {
//            posCopy.add(new Vector3f(0, 1, 0).mul(-delta*jumpSpeed));
//        }

        if(main.getMouse().isButtonPressed(GLFW.GLFW_MOUSE_BUTTON_1)) {
            if(!keyLeftIsDown) {
                keyLeftIsDown = true;
                Vector3d tmpPos = new Vector3d(ViewportCamera.pos);
                for (int i = 0; i < 1000; i++) {
                    Vector3i bPos = new Vector3i((int) (tmpPos.x+0.5), (int) (tmpPos.y+0.5), (int) (tmpPos.z+0.5));
                    if (World.getBlockAt(bPos.x, bPos.y, bPos.z).isSolid()) {
                        World.setBlockAt(bPos.x, bPos.y, bPos.z, Blocks.AIR);
                        break;
                    }
                    tmpPos.add(new Vector3f(ViewportCamera.forwardVector()).div(100.0f));
                }
            }
        } else {
            keyLeftIsDown = false;
        }

        if(main.getMouse().isButtonPressed(GLFW.GLFW_MOUSE_BUTTON_2)) {
            if(!keyRightIsDown) {
                keyRightIsDown = true;
                Vector3d tmpPos = new Vector3d(ViewportCamera.pos);
                for (int i = 0; i < 1000; i++) {
                    Vector3d cent = new Vector3d(tmpPos.x+0.5, tmpPos.y+0.5, tmpPos.z+0.5);
                    Vector3i bPos = new Vector3i((int)cent.x, (int)cent.y, (int)cent.z);
                    if (World.getBlockAt(bPos.x, bPos.y, bPos.z).isSolid()) {
                        Vector3d dir = new Vector3d(tmpPos).sub(new Vector3d(bPos).add(new Vector3d(0.0)));
                        Vector3i dirI = axisAlign(dir);
                        Vector3i bPosO = new Vector3i(bPos).add(dirI);
                        if(World.getBlockAt(bPosO.x, bPosO.y, bPosO.z).isSolid()) {
                            System.out.println(dir);
                            System.out.println(dirI);
                        } else {
                            World.setBlockAt(bPosO.x, bPosO.y, bPosO.z, Blocks.STONE);
                        }
                        break;
                    }
                    tmpPos.add(new Vector3f(ViewportCamera.forwardVector()).div(100.0f));
                }
            }
        } else {
            keyRightIsDown = false;
        }

        if(main.getKeyboard().isKeyDown(GLFW.GLFW_KEY_SPACE)) {
            //if(isOnGround()) {
                posCopy.add(new Vector3f(0, 1, 0).mul(delta*jumpSpeed));
            //}
        }

        PlayerVelocity.vel.add(posCopy);
    }
}
