package ity.opencraft.util;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.stream.Collectors;

public class StringLoader {

    /**
     * make a stream out of a path
     * @param path the path to the resource
     * @return the stream
     */
    public static InputStream loadResourceAsStream(String path) {
        return StringLoader.class.getClassLoader().getResourceAsStream(path);
    }

    /**
     * read a text file from a path
     * @param path path to the text file
     * @return the contents of the text file as a string
     */
    public static String loadResourceAsString(String path) {
        return new BufferedReader(new InputStreamReader(loadResourceAsStream(path))).lines().collect(Collectors.joining("\n"));
    }
}