package ity.opencraft.world;

import ity.opencraft.data.BlockMeshData;
import ity.opencraft.data.BlockMeshHandle;
import org.joml.Vector3i;

public class Chunk {
    public static final int size = 32;
    private boolean freed = false;

    public Vector3i pos;
    public BlockMeshHandle meshHandle;
    public BlockMeshData meshData;
    public BlockMeshHandle meshHandle2;
    public BlockMeshData meshData2;

    private Block[] blocks = new Block[size*size*size];
    //private float[] lights = new float[size*size*size];


    public Chunk(Vector3i pos) {
        this.pos = pos;
    }

    public Block getBlockAt(int x, int y, int z) {
        return blocks[x*size*size+y*size+z];
    }

    public void setBlockAt(int x, int y, int z, Block block) {
        blocks[x*size*size+y*size+z] = block;
    }

    public float getLightAt(int x, int y, int z) {
        //return lights[x*size*size+y*size+z];
        return 0;
    }

    public void setLightAt(int x, int y, int z, float level) {
        //lights[x*size*size+y*size+z] = level;
    }

    public void free() {
        if(!freed) {
            blocks = null;
            if(meshHandle != null)
                meshHandle.free();
            meshHandle = null;
            if(meshHandle2 != null)
                meshHandle2.free();
            meshHandle2 = null;
            freed = true;
        } else {
            throw new IllegalStateException("Double free");
        }
    }
}
