package ity.opencraft.world.blocks;

import ity.opencraft.world.BlockSide;
import ity.opencraft.world.Block;
import ity.opencraft.world.World;
import org.joml.Vector3i;

public class BlockGrass extends Block {
    @Override
    public boolean isTransparent(Block blockSide) {
        return false;
    }

    @Override
    public int textureIndex(BlockSide side, Vector3i pos) {
        switch(side) {
            case TOP:
                return 2;
            case LEFT:
                if(World.getBlockAt(pos.x-1, pos.y-1, pos.z).textureIndex(BlockSide.TOP, new Vector3i(pos.x-1, pos.y-1, pos.z)) == 2) return 2;
                else return 0;
            case RIGHT:
                if(World.getBlockAt(pos.x+1, pos.y-1, pos.z).textureIndex(BlockSide.TOP, new Vector3i(pos.x+1, pos.y-1, pos.z)) == 2) return 2;
                else return 0;
            case FRONT:
                if(World.getBlockAt(pos.x, pos.y-1, pos.z+1).textureIndex(BlockSide.TOP, new Vector3i(pos.x, pos.y-1, pos.z+1)) == 2) return 2;
                else return 0;
            case BACK:
                if(World.getBlockAt(pos.x, pos.y-1, pos.z-1).textureIndex(BlockSide.TOP, new Vector3i(pos.x, pos.y-1, pos.z-1)) == 2) return 2;
                else return 0;
            case BOTTOM:
                return 3;
        }
        return -1;
    }

    @Override
    public boolean textureRotate(BlockSide side) {
        return side.equals(BlockSide.BOTTOM);
    }

    @Override
    public boolean isSolid() {
        return true;
    }
}
