#version 460

in vec3 fragPos;

uniform vec2 iRes;
uniform float blueAlpha;

out vec4 color;

const float innerRadius = 0.0040;
const float outerRadius = 0.0050;

void main() {
    vec2 uv = gl_FragCoord.xy/iRes*vec2(2.0)-vec2(1.0);
    uv.x *= iRes.x / iRes.y;
    float dist = length(vec2(0,0)-uv);
    color = vec4(vec3(1.), 1.);
    if(dist > innerRadius) {
        if(dist > outerRadius) {
            color = vec4(0.1, 0.1, 1.0, blueAlpha);
        }
        else {
            color = vec4(vec3(1.), 1-(dist-innerRadius)*(1/(outerRadius-innerRadius)));
        }
    }
}